package com.climate.data.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 气候舒适表里面包含人体舒适指数、气候度假指数
 */
@Data
public class CliComfort {
	/** 主键id */
	private Long id;
	/** 时间 */
	@JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
	@DateTimeFormat(pattern="yyyy-MM-dd")
	private Date dataTime;
	/** 区县名 */
	private String cnty;
	/** 人体舒适指数 */
	private Double peoComIndex;
	/** 气候度假指数 */
	private Double cliVacIndex;

}
