package com.climate.data.domain.vo;

import lombok.Data;

import java.math.BigDecimal;
import java.util.List;

/**
 * 参数实体
 * @author yhy
 */
@Data
public class TqParm {

    /**
     * 区站号(字符)
     **/
    private String distStationId;
    /**
     * 站名
     **/
    private String stationName;
    /**
     *
     * */
    private Integer pageNum;
    /**
     * 页面大小
     * */
    private Integer pageSize;

    /**
     * 传入查询时间
     */
    private String time;
    /**
     * 结束时间
     */
    private String endTime;
    /**
     * 开始时间
     */
    private String startTime;
    /**
     * 经度
     */
    private BigDecimal geomLongitu;

    /**
     * 纬度
     */
    private BigDecimal geomLatitu;

    /**
     * 根据站号集合查询站点信息的参数
     */
    private List<String> stationId;
    /**
     * 根据站号查询站点信息的参数
     */
    private String staId;

    /**
     * 起始经度
     */
    private String minLon;

    /**
     * 起始纬度
     */
    private String minLat;

    /**
     * 终止经度
     */
    private String maxLon;

    /**
     * 终止纬度
     */
    private String maxLat;

    /**
     * 风场数据请求时间
     */
    private String observedTime;

    /**
     * 区域码
     * */
    private String adminCodes;
    /**
     * 类型 0-存入降水数据 1-存入平均温度数据
     * */
    private int type;
    /**
     * 获取多少年数据
     * */
    private int years;
    /**
     * 等级预报天数
     * */
    private int foreDays;
    /**
     * 等级2.0需要时间
     * 示例：2023-12-20 14:00:00
     * */
    private String foreTime;
    /**
     * 类型 1-风速 2-气温 3-湿度 4-雪深
     * */
    private  int num;
    //  private Integer hour;

}

