package com.climate.data.mapper;

import com.climate.data.domain.CliComfort;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

@Mapper
public interface CliComfortMapper {

	/**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
	List<CliComfort> listAll();


	/**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
	CliComfort getById(Long id);

	/**
     * 新增，插入所有字段
     *
     * @param cliComfort 新增的记录
     * @return 返回影响行数
     */
	int insert(CliComfort cliComfort);

	/**
     * 新增，忽略null字段
     *
     * @param cliComfort 新增的记录
     * @return 返回影响行数
     */
	int insertIgnoreNull(CliComfort cliComfort);

	/**
     * 修改，修改所有字段
     *
     * @param cliComfort 修改的记录
     * @return 返回影响行数
     */
	int update(CliComfort cliComfort);

	/**
     * 修改，忽略null字段
     *
     * @param cliComfort 修改的记录
     * @return 返回影响行数
     */
	int updateIgnoreNull(CliComfort cliComfort);

	/**
     * 删除记录
     *
     * @param cliComfort 待删除的记录
     * @return 返回影响行数
     */
	int delete(CliComfort cliComfort);

}
