package com.climate.data.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.climate.data.domain.CliTqStation;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @author
 */
@Repository
public interface CliTqStationMapper extends BaseMapper<CliTqStation> {

	/**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
	List<CliTqStation> listAll();


	/**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
	CliTqStation getById(Long id);

	/**
     * 新增，插入所有字段
     *
     * @param cliTqStation 新增的记录
     * @return 返回影响行数
     */
	int insertGeom(CliTqStation cliTqStation);
	/**
	 * 批量插入
	 * @param cliTqStations
	 * @return
	 * */
	int insertBatch(List<CliTqStation> cliTqStations);

	/**
     * 新增，忽略null字段
     *
     * @param cliTqStation 新增的记录
     * @return 返回影响行数
     */
	int insertIgnoreNull(CliTqStation cliTqStation);

	/**
     * 修改，修改所有字段
     *
     * @param cliTqStation 修改的记录
     * @return 返回影响行数
     */
	int update(CliTqStation cliTqStation);

	/**
     * 修改，忽略null字段
     *
     * @param cliTqStation 修改的记录
     * @return 返回影响行数
     */
	int updateIgnoreNull(CliTqStation cliTqStation);

	/**
     * 删除记录
     *
     * @param cliTqStation 待删除的记录
     * @return 返回影响行数
     */
	int delete(CliTqStation cliTqStation);

}
