package com.climate.data.run;

import com.climate.data.utils.QueryClient;
import com.climate.data.utils.QueryUtils;
import com.climate.data.utils.TqConfig;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.stereotype.Component;

@Component
@Slf4j
public class ApplicationRunnerImpl implements ApplicationRunner {
    @Autowired
    private TqConfig tqConfig;

    @Override
    public void run(ApplicationArguments args) {
        log.info("初始化天擎--开始");
        QueryClient queryClient = new QueryClient(tqConfig.getPath());
        if(queryClient !=null){
            QueryUtils queryUtils = new QueryUtils(queryClient);
            log.info("初始化天擎--完成");
        }
    }

}
