package com.climate.data.utils;
import cma.music.*;
import cma.music.utils.CommHelper;
import cma.music.utils.ConfigHelper;
import cma.music.utils.HttpDownLoad;
import com.alibaba.fastjson.JSON;
import org.apache.http.HttpEntity;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;

import java.io.File;
import java.io.IOException;
import java.util.*;

/**
 * @author 小p同学
 */
public class QueryClient {
    /*static final String config = "D:\\ideaworksprace\\weather_service\\weather-modules\\weather-data\\client.config";*/
    private static String basicUrl = "http://ip:port/music-ws/api?serviceNodeId=serverId&";
    String config = null;
    String serverIp = "";
    String serverPort = "80";
    int connTimeOut = 3000;
    int readTimeOut = 900000;
    String serverID = "NMIC_MUSIC_CMADAAS";
    static final int OTHER_ERROR = -10001;
    static String language = "JAVA";
    static String clientVersion = "V2.0.0";
    static String getwayFlag = "\"flag\":\"slb\"";
    static final String serverKey = "music_server";
    static final String portKey = "music_port";
    static final String connTimeoutKey = "music_connTimeout";
    static final String readTimeoutKey = "music_readTimeout";
    static final String defaultServiceIdKey = "music_ServiceId";
    static final String storeBackStageKey = "music_store_backstage";
    static final String localMountKey = "music_local_mount";
    static final String serverMountKey = "music_server_mount";
    static int tick = 0;

    public QueryClient(String path) {
        this.config = path;
    }


    public void initResources() throws Exception {
        File f = new File(this.config);
        if (!f.exists()) {
            throw new Exception("Error,client.config not exists  ");
        } else {
            this.readClientConfig(this.config);
        }
    }

    public void initResources(String path) throws Exception {
        File f = new File(path);
        if (!f.exists()) {
            throw new Exception("Error,client.config not exists  ");
        } else {
            this.readClientConfig(path);
        }
    }

    public void initResources(String musicIp, String musicPort) throws Exception {
        this.initResources();
        if (musicIp != null && !musicIp.isEmpty()) {
            this.serverIp = musicIp;
        }

        if (musicPort != null && !musicPort.isEmpty()) {
            this.serverPort = musicPort;
        }

    }

    public void initResources(String musicIp, String musicPort, int connTimeout, int readTimeout) throws Exception {
        this.initResources();
        if (musicIp != null && !musicIp.isEmpty()) {
            this.serverIp = musicIp;
        }

        if (musicPort != null && !musicPort.isEmpty()) {
            this.serverPort = musicPort;
        }

        if (connTimeout > 0 && connTimeout < 2147483647) {
            this.connTimeOut = connTimeout * 1000;
        }

        if (readTimeout > 0 && readTimeout < 2147483647) {
            this.readTimeOut = readTimeout * 1000;
        }

    }

    public void destroyResources() {
        ++tick;
        if (tick > 50) {
            System.gc();
            tick = 0;
        }

    }

    public int callAPI_to_array2D(String userId, String pwd, String interfaceId, HashMap<String, String> params, RetArray2D retArray2D) {
        return this.callAPI_to_array2D(userId, pwd, interfaceId, (String) null, params, retArray2D);
    }

    public int callAPI_to_array2D(String userId, String pwd, String interfaceId, String serverID, HashMap<String, String> params, RetArray2D retArray2D) {
        String method = "callAPI_to_array2D";

        int retCode;
        try {
            List<byte[]> retBytes = new ArrayList();
            this.getQueryBytes(userId, pwd, interfaceId, serverID, params, method, retBytes);
            byte[] buf = (byte[]) retBytes.get(0);

            String retStr = new String(buf);
            if (retStr.contains(getwayFlag)) {
                RetGetway retGetway = (RetGetway) JSON.parseObject(retStr, RetGetway.class);
                retCode = retGetway.getReturnCode();
                retArray2D.setRequestInfo(new RequestInfo());
                retArray2D.getRequestInfo().setErrorCode(retCode);
                retArray2D.getRequestInfo().setErrorMessage(retGetway.getReturnMessage());
            } else {
                Apiinterface.RetArray2D _retArray2D = Apiinterface.RetArray2D.parseFrom(buf);
                RetArray2D retArray2d = null;
                retArray2d = DataFormatChange.getArray2D(_retArray2D);
                if (retArray2d != null) {
                    retCode = retArray2d.getRequestInfo().getErrorCode();
                    retArray2D.setRequestInfo(retArray2d.getRequestInfo());
                    retArray2D.data = retArray2d.data;
                    retArray2D.setCol(retArray2d.getCol());
                    retArray2D.setRow(retArray2d.getRow());
                    retArray2D.setElementNames(retArray2d.getElementNames());
                } else {
                    retCode = -10001;
                    retArray2D.setRequestInfo(new RequestInfo());
                    retArray2D.getRequestInfo().setErrorCode(-10001);
                    retArray2D.getRequestInfo().setErrorMessage("error:DataFormatChange.getArray2D");
                }

                retBytes.clear();
            }

            retStr = null;
        } catch (IOException var14) {
            var14.printStackTrace();
            retCode = -10001;
            retArray2D.setRequestInfo(new RequestInfo());
            retArray2D.getRequestInfo().setErrorCode(-10001);
            retArray2D.getRequestInfo().setErrorMessage(var14.getMessage());
        } catch (Exception var15) {
            var15.printStackTrace();
            retCode = -10001;
            retArray2D.setRequestInfo(new RequestInfo());
            retArray2D.getRequestInfo().setErrorCode(-10001);
            retArray2D.getRequestInfo().setErrorMessage(var15.getMessage());
        }

        return retCode;
    }

    public int callAPI_to_gridArray2D(String userId, String pwd, String interfaceId, HashMap<String, String> params, RetGridArray2D retGridArray2D) {
        return this.callAPI_to_gridArray2D(userId, pwd, interfaceId, (String) null, params, retGridArray2D);
    }

    public int callAPI_to_gridArray2D(String userId, String pwd, String interfaceId, String serverID, HashMap<String, String> params, RetGridArray2D retGridArray2D) {
        RetGridArray2D retArray2d = null;
        if (retGridArray2D == null) {
            retGridArray2D = new RetGridArray2D();
        }


        String method = "callAPI_to_gridArray2D";

        int retCode;
        try {
            List<byte[]> retBytes = new ArrayList();
            this.getQueryBytes(userId, pwd, interfaceId, serverID, params, method, retBytes);
            byte[] buf = retBytes.get(0);
            String retStr = new String(buf);
            if (retStr.contains(getwayFlag)) {
                RetGetway retGetway = (RetGetway) JSON.parseObject(retStr, RetGetway.class);
                retCode = retGetway.getReturnCode();
                retGridArray2D.setRequestInfo(new RequestInfo());
                retGridArray2D.getRequestInfo().setErrorCode(retCode);
                retGridArray2D.getRequestInfo().setErrorMessage(retGetway.getReturnMessage());
            } else {
                Apiinterface.RetGridArray2D _retArray2D = Apiinterface.RetGridArray2D.parseFrom(buf);
                retArray2d = DataFormatChange.getGridArray2D(_retArray2D);
                if (retArray2d != null) {
                    retCode = retArray2d.getRequestInfo().getErrorCode();
                    retGridArray2D.setRequestInfo(retArray2d.getRequestInfo());
                    retGridArray2D.data = retArray2d.data;
                    retGridArray2D.setStartLat(retArray2d.getStartLat());
                    retGridArray2D.setStartLon(retArray2d.getStartLon());
                    retGridArray2D.setEndLat(retArray2d.getEndLat());
                    retGridArray2D.setEndLon(retArray2d.getEndLon());
                    retGridArray2D.setLatCount(retArray2d.getLatCount());
                    retGridArray2D.setLonCount(retArray2d.getLonCount());
                    retGridArray2D.setLonStep(retArray2d.getLonStep());
                    retGridArray2D.setLatStep(retArray2d.getLatStep());
                    retGridArray2D.setUnits(retArray2d.getUnits());
                    retGridArray2D.setUserEleName(retArray2d.getUserEleName());
                    retGridArray2D.setLats(retArray2d.getLats());
                    retGridArray2D.setLons(retArray2d.getLons());
                } else {
                    retCode = -10001;
                    retGridArray2D.setRequestInfo(new RequestInfo());
                    retGridArray2D.getRequestInfo().setErrorCode(-10001);
                    retGridArray2D.getRequestInfo().setErrorMessage("error:DataFormatChange.getGridArray2D");
                }

                retBytes.clear();
            }

            retStr = null;
        } catch (Exception var14) {
            var14.printStackTrace();
            retCode = -10001;
            retGridArray2D.setRequestInfo(new RequestInfo());
            retGridArray2D.getRequestInfo().setErrorCode(-10001);
            retGridArray2D.getRequestInfo().setErrorMessage(var14.getMessage());
        }

        return retCode;
    }

    public int callAPI_to_gridScalar2D(String userId, String pwd, String interfaceId, HashMap<String, String> params, RetGridScalar2D retGridArray2D) {
        return this.callAPI_to_gridScalar2D(userId, pwd, interfaceId, (String) null, params, retGridArray2D);
    }

    public int callAPI_to_gridScalar2D(String userId, String pwd, String interfaceId, String serverID, HashMap<String, String> params, RetGridScalar2D retGridArray2D) {
        RetGridScalar2D retArray2d = null;
        if (retGridArray2D == null) {
            retGridArray2D = new RetGridScalar2D();
        }

        String method = "callAPI_to_gridScalar2D";

        int retCode;
        try {
            List<byte[]> retBytes = new ArrayList();
            this.getQueryBytes(userId, pwd, interfaceId, serverID, params, method, retBytes);
            byte[] buf = retBytes.get(0);
            String retStr = new String(buf);
            if (retStr.contains(getwayFlag)) {
                RetGetway retGetway = (RetGetway) JSON.parseObject(retStr, RetGetway.class);
                retCode = retGetway.getReturnCode();
                retGridArray2D.setRequestInfo(new RequestInfo());
                retGridArray2D.getRequestInfo().setErrorCode(retCode);
                retGridArray2D.getRequestInfo().setErrorMessage(retGetway.getReturnMessage());
            } else {
                Apiinterface.RetGridScalar2D _retArray2D = Apiinterface.RetGridScalar2D.parseFrom(buf);
                retArray2d = DataFormatChange.getGridScalar2D(_retArray2D);
                if (retArray2d != null) {
                    retCode = retArray2d.getRequestInfo().getErrorCode();
                    retGridArray2D.setRequestInfo(retArray2d.getRequestInfo());
                    retGridArray2D.setDatas(retArray2d.getDatas());
                    retGridArray2D.setEndLat(retArray2d.getEndLat());
                    retGridArray2D.setEndLon(retArray2d.getEndLon());
                    retGridArray2D.setStartLat(retArray2d.getStartLat());
                    retGridArray2D.setStartLon(retArray2d.getStartLon());
                    retGridArray2D.setLatCount(retArray2d.getLatCount());
                    retGridArray2D.setLonCount(retArray2d.getLonCount());
                    retGridArray2D.setLonStep(retArray2d.getLonStep());
                    retGridArray2D.setLatStep(retArray2d.getLatStep());
                    retGridArray2D.setUnits(retArray2d.getUnits());
                    retGridArray2D.setUserEleName(retArray2d.getUserEleName());
                    retGridArray2D.setLats(retArray2d.getLats());
                    retGridArray2D.setLons(retArray2d.getLons());
                } else {
                    retCode = -10001;
                    retGridArray2D.setRequestInfo(new RequestInfo());
                    retGridArray2D.getRequestInfo().setErrorCode(-10001);
                    retGridArray2D.getRequestInfo().setErrorMessage("error:DataFormatChange.getGridScalar2D");
                }

                retBytes.clear();
            }

            retStr = null;
        } catch (Exception var14) {
            var14.printStackTrace();
            retCode = -10001;
            retGridArray2D.setRequestInfo(new RequestInfo());
            retGridArray2D.getRequestInfo().setErrorCode(-10001);
            retGridArray2D.getRequestInfo().setErrorMessage(var14.getMessage());
        }

        return retCode;
    }

    public int callAPI_to_gridVector2D(String userId, String pwd, String interfaceId, HashMap<String, String> params, RetGridVector2D retGridArray2D) {
        return this.callAPI_to_gridVector2D(userId, pwd, interfaceId, (String) null, params, retGridArray2D);
    }

    public int callAPI_to_gridVector2D(String userId, String pwd, String interfaceId, String serverID, HashMap<String, String> params, RetGridVector2D retGridArray2D) {
        RetGridVector2D retArray2d = null;
        if (retGridArray2D == null) {
            retGridArray2D = new RetGridVector2D();
        }

        String method = "callAPI_to_gridVector2D";

        int retCode;
        try {
            List<byte[]> retBytes = new ArrayList();
            this.getQueryBytes(userId, pwd, interfaceId, serverID, params, method, retBytes);
            byte[] buf = retBytes.get(0);
            ;
            String retStr = new String(buf);
            if (retStr.contains(getwayFlag)) {
                RetGetway retGetway = (RetGetway) JSON.parseObject(retStr, RetGetway.class);
                retCode = retGetway.getReturnCode();
                retGridArray2D.setRequestInfo(new RequestInfo());
                retGridArray2D.getRequestInfo().setErrorCode(retCode);
                retGridArray2D.getRequestInfo().setErrorMessage(retGetway.getReturnMessage());
            } else {
                Apiinterface.RetGridVector2D _retArray2D = Apiinterface.RetGridVector2D.parseFrom(buf);
                retArray2d = DataFormatChange.getGridVector2D(_retArray2D);
                if (retArray2d != null) {
                    retCode = retArray2d.getRequestInfo().getErrorCode();
                    retGridArray2D.setU_datas(retArray2d.getU_datas());
                    retGridArray2D.setV_datas(retArray2d.getV_datas());
                    retGridArray2D.setRequestInfo(retArray2d.getRequestInfo());
                    retGridArray2D.setEndLat(retArray2d.getEndLat());
                    retGridArray2D.setEndLon(retArray2d.getEndLon());
                    retGridArray2D.setStartLat(retArray2d.getStartLat());
                    retGridArray2D.setStartLon(retArray2d.getStartLon());
                    retGridArray2D.setLatCount(retArray2d.getLatCount());
                    retGridArray2D.setLonCount(retArray2d.getLonCount());
                    retGridArray2D.setLonStep(retArray2d.getLonStep());
                    retGridArray2D.setLatStep(retArray2d.getLatStep());
                    retGridArray2D.setU_EleName(retArray2d.getU_EleName());
                    retGridArray2D.setV_EleName(retArray2d.getV_EleName());
                    retGridArray2D.setLats(retArray2d.getLats());
                    retGridArray2D.setLons(retArray2d.getLons());
                } else {
                    retCode = -10001;
                    retGridArray2D.setRequestInfo(new RequestInfo());
                    retGridArray2D.getRequestInfo().setErrorCode(-10001);
                    retGridArray2D.getRequestInfo().setErrorMessage("error:DataFormatChange.getGridVector2D");
                }

                retBytes.clear();
            }

            retStr = null;
        } catch (Exception var14) {
            var14.printStackTrace();
            retCode = -10001;
            retGridArray2D.setRequestInfo(new RequestInfo());
            retGridArray2D.getRequestInfo().setErrorCode(-10001);
            retGridArray2D.getRequestInfo().setErrorMessage(var14.getMessage());
        }

        return retCode;
    }

    public int callAPI_to_fileList(String userId, String pwd, String interfaceId, HashMap<String, String> params, RetFilesInfo retFilesInfo) {
        return this.callAPI_to_fileList(userId, pwd, interfaceId, (String) null, params, retFilesInfo);
    }

    public int callAPI_to_fileList(String userId, String pwd, String interfaceId, String serverID, HashMap<String, String> params, RetFilesInfo retFilesInfo) {
        RetFilesInfo retFileList = null;
        if (retFilesInfo == null) {
            retFilesInfo = new RetFilesInfo();
        }


        String method = "callAPI_to_fileList";

        int retCode;
        try {
            List<byte[]> retBytes = new ArrayList();
            this.getQueryBytes(userId, pwd, interfaceId, serverID, params, method, retBytes);
            byte[] buf = retBytes.get(0);
            String retStr = new String(buf);
            if (retStr.contains(getwayFlag)) {
                RetGetway retGetway = (RetGetway) JSON.parseObject(retStr, RetGetway.class);
                retCode = retGetway.getReturnCode();
                retFilesInfo.setRequestInfo(new RequestInfo());
                retFilesInfo.getRequestInfo().setErrorCode(retCode);
                retFilesInfo.getRequestInfo().setErrorMessage(retGetway.getReturnMessage());
            } else {
                Apiinterface.RetFilesInfo _pbResult = Apiinterface.RetFilesInfo.parseFrom(buf);
                retFileList = DataFormatChange.getRetFilesInfo(_pbResult);
                if (retFileList != null) {
                    retCode = retFileList.getRequestInfo().getErrorCode();
                    retFilesInfo.setRequestInfo(retFileList.getRequestInfo());
                    retFilesInfo.fileInfos = retFileList.fileInfos;
                    retFilesInfo.setCount(retFileList.getCount());
                } else {
                    retCode = -10001;
                    retFilesInfo.setRequestInfo(new RequestInfo());
                    retFilesInfo.getRequestInfo().setErrorCode(-10001);
                    retFilesInfo.getRequestInfo().setErrorMessage("error:DataFormatChange.getRetFilesInfo");
                }

                retBytes.clear();
            }

            retStr = null;
        } catch (Exception var14) {
            var14.printStackTrace();
            retCode = -10001;
            retFilesInfo.setRequestInfo(new RequestInfo());
            retFilesInfo.getRequestInfo().setErrorCode(-10001);
            retFilesInfo.getRequestInfo().setErrorMessage(var14.getMessage());
        }

        return retCode;
    }

    public int callAPI_to_serializedStr(String userId, String pwd, String interfaceId, HashMap<String, String> params, String dataFormat, StringBuffer retStr) {
        return this.callAPI_to_serializedStr(userId, pwd, interfaceId, (String) null, params, dataFormat, retStr);
    }

    public int callAPI_to_serializedStr(String userId, String pwd, String interfaceId, String serverID, HashMap<String, String> params, String dataFormat, StringBuffer retStr) {

        String method = "callAPI_to_serializedStr";
        params.put("dataFormat", dataFormat);

        int retCode;
        try {
            List<byte[]> retBytes = new ArrayList();
            retCode = this.getQueryBytes(userId, pwd, interfaceId, serverID, params, method, retBytes);
            byte[] buf = retBytes.get(0);
            String retValStr = new String(buf);
            if (retValStr.contains(getwayFlag)) {
                RetGetway retGetway = (RetGetway) JSON.parseObject(retValStr, RetGetway.class);
                retCode = retGetway.getReturnCode();
                retStr.append(retGetway.getReturnMessage());
            } else {
                String retStrValue = new String(buf, "UTF-8");
                retStr.append(retStrValue);
                retBytes.clear();
            }

            retValStr = null;
        } catch (Exception var14) {
            var14.printStackTrace();
            retCode = -10001;
            retStr.append(var14.getMessage());
        }

        return retCode;
    }

    public int callAPI_to_saveAsFile(String userId, String pwd, String interfaceId, HashMap<String, String> params, String dataFormat, String savePath, RetFilesInfo retFilesInfo) {
        return this.callAPI_to_saveAsFile(userId, pwd, interfaceId, (String) null, params, dataFormat, savePath, retFilesInfo);
    }

    public int callAPI_to_saveAsFile(String userId, String pwd, String interfaceId, String serverID, HashMap<String, String> params, String dataFormat, String savePath, RetFilesInfo retFilesInfo) {
        int retCode = -10001;
        RetFilesInfo retFileList = null;
        if (retFilesInfo == null) {
            retFilesInfo = new RetFilesInfo();
        }

        if (savePath != null && savePath.length() >= 1) {
            CommHelper.createDir(savePath);
            params.put("savePath", savePath);
            params.put("dataFormat", dataFormat);
            String method = "callAPI_to_saveAsFile";
            try {
                List<byte[]> retBytes = new ArrayList();
                this.getQueryBytes(userId, pwd, interfaceId, serverID, params, method, retBytes);
                byte[] buf = retBytes.get(0);;
                String retStr = new String(buf);
                if (retStr.contains(getwayFlag)) {
                    RetGetway retGetway = (RetGetway) JSON.parseObject(retStr, RetGetway.class);
                    retCode = retGetway.getReturnCode();
                    retFilesInfo.setRequestInfo(new RequestInfo());
                    retFilesInfo.getRequestInfo().setErrorCode(retCode);
                    retFilesInfo.getRequestInfo().setErrorMessage(retGetway.getReturnMessage());
                } else {
                    Apiinterface.RetFilesInfo _pbResult = Apiinterface.RetFilesInfo.parseFrom(buf);
                    retFileList = DataFormatChange.getRetFilesInfo(_pbResult);
                    if (retFileList != null) {
                        retCode = retFileList.getRequestInfo().getErrorCode();
                        retFilesInfo.fileInfos = retFileList.fileInfos;
                        retFilesInfo.setRequestInfo(retFileList.getRequestInfo());
                        retFilesInfo.setCount(retFileList.getCount());
                    } else {
                        retCode = -10001;
                        retFilesInfo.setRequestInfo(new RequestInfo());
                        retFilesInfo.getRequestInfo().setErrorCode(-10001);
                        retFilesInfo.getRequestInfo().setErrorMessage("error:DataFormatChange.getRetFilesInfo");
                    }

                    retBytes.clear();
                }

                retStr = null;
            } catch (Exception var16) {
                var16.printStackTrace();
                retCode = -10001;
                retFilesInfo.setRequestInfo(new RequestInfo());
                retFilesInfo.getRequestInfo().setErrorCode(-10001);
                retFilesInfo.getRequestInfo().setErrorMessage(var16.getMessage());
            }

            if (retCode == 0) {
                String fileurl = retFilesInfo.fileInfos[0].getFileUrl();
                boolean ret = HttpDownLoad.httpDownload(fileurl, savePath);
                if (ret) {
                    retCode = 0;
                } else {
                    retFilesInfo.getRequestInfo().setErrorCode(-10001);
                    retFilesInfo.getRequestInfo().setErrorMessage("error,httpDownload file:" + fileurl);
                }
            }

            return retCode;
        } else {
            System.out.println("error:savePath can't is null");
            retFilesInfo.setRequestInfo(new RequestInfo());
            retFilesInfo.getRequestInfo().setErrorCode(retCode);
            retFilesInfo.getRequestInfo().setErrorMessage("error:savePath can't is null,the format is dir/file.formart(ex. /data/saveas.xml)");
            return retCode;
        }
    }

    public int callAPI_to_downFile(String userId, String pwd, String interfaceId, HashMap<String, String> params, String saveDir, RetFilesInfo retFilesInfo) {
        return this.callAPI_to_downFile(userId, pwd, interfaceId, (String) null, params, saveDir, retFilesInfo);
    }

    public int callAPI_to_downFile(String userId, String pwd, String interfaceId, String serverID, HashMap<String, String> params, String saveDir, RetFilesInfo retFilesInfo) {
        CommHelper.createDir(saveDir);
        CommHelper.createSingleDir(saveDir);
        int retCode = this.callAPI_to_fileList(userId, pwd, interfaceId, serverID, params, retFilesInfo);
        if (retCode == 0 && retFilesInfo != null) {
            FileInfo[] var12;
            int var11 = (var12 = retFilesInfo.fileInfos).length;

            for (int var10 = 0; var10 < var11; ++var10) {
                FileInfo fileinfo = var12[var10];
                String fileURL = fileinfo.getFileUrl();
                String savePath = saveDir + fileinfo.getFileName();
                if (!HttpDownLoad.httpDownload(fileURL, savePath)) {
                    retCode = -10001;
                    retFilesInfo.getRequestInfo().setErrorCode(-10001);
                    retFilesInfo.getRequestInfo().setErrorMessage("download file error,fileURL=" + fileURL + "savePath=" + savePath);
                    break;
                }
            }
        }

        return retCode;
    }

    public int callAPI_to_dataBlock(String userId, String pwd, String interfaceId, HashMap<String, String> params, RetDataBlock retDataBlock) {
        return this.callAPI_to_dataBlock(userId, pwd, interfaceId, (String) null, params, retDataBlock);
    }

    public int callAPI_to_dataBlock(String userId, String pwd, String interfaceId, String serverID, HashMap<String, String> params, RetDataBlock retDataBlock) {
        RetDataBlock dataBlock = null;
        if (retDataBlock == null) {
            retDataBlock = new RetDataBlock();
        }

        String method = "callAPI_to_dataBlock";

        int retCode;
        try {

            List<byte[]> retBytes = new ArrayList();
            this.getQueryBytes(userId, pwd, interfaceId, serverID, params, method, retBytes);
            byte[] buf = (byte[]) retBytes.get(0);
            String retStr = new String(buf);
            if (retStr.contains(getwayFlag)) {
                RetGetway retGetway = (RetGetway) JSON.parseObject(retStr, RetGetway.class);
                retCode = retGetway.getReturnCode();
                retDataBlock.setRequestInfo(new RequestInfo());
                retDataBlock.getRequestInfo().setErrorCode(retCode);
                retDataBlock.getRequestInfo().setErrorMessage(retGetway.getReturnMessage());
            } else {
                Apiinterface.RetDataBlock _retDataBlock = Apiinterface.RetDataBlock.parseFrom(buf);
                dataBlock = DataFormatChange.getRetDataBlock(_retDataBlock);
                if (dataBlock != null) {
                    retCode = dataBlock.getRequestInfo().getErrorCode();
                    retDataBlock.setByteArray(dataBlock.getByteArray());
                    retDataBlock.setDataName(dataBlock.getDataName());
                    retDataBlock.setRequestInfo(dataBlock.getRequestInfo());
                } else {
                    retCode = -10001;
                    retDataBlock.setRequestInfo(new RequestInfo());
                    retDataBlock.getRequestInfo().setErrorCode(retCode);
                    retDataBlock.getRequestInfo().setErrorMessage("error:DataFormatChange.getRetDataBlock");
                }

                retBytes.clear();
            }

            retStr = null;
        } catch (Exception var14) {
            var14.printStackTrace();
            retCode = -10001;
            retDataBlock.setRequestInfo(new RequestInfo());
            retDataBlock.getRequestInfo().setErrorCode(retCode);
            retDataBlock.getRequestInfo().setErrorMessage(var14.getMessage());
        }

        return retCode;
    }

    public int callAPI_to_downFile_ByUrl(String fileURL, String save_as) {
        int errorCode = -10001;
        if (fileURL != null && !fileURL.isEmpty() && save_as != null && !save_as.isEmpty()) {
            if (HttpDownLoad.httpDownload(fileURL, save_as)) {
                errorCode = 0;
            } else {
                System.out.println("下载文件失败");
            }
        } else {
            System.out.println("下载文件url或保存路径为空");
        }

        return errorCode;
    }

    public byte[] callAPI_to_downFileByte(String fileURL) {
        byte[] buffer = null;
        if (fileURL != null && fileURL.length() != 0) {
            try {
                buffer = HttpDownLoad.httpDownloadByte(fileURL);
                String retStr = new String(buffer);
                if (retStr.contains(getwayFlag)) {
                    RetGetway retGetway = (RetGetway) JSON.parseObject(retStr, RetGetway.class);
                    System.out.println("slb error:returnCode=" + retGetway.getReturnCode() + " returnMessage=" + retGetway.getReturnMessage());
                    return null;
                }
            } catch (Exception var5) {
                var5.printStackTrace();
                return null;
            }
        }

        return buffer;
    }

    private int getQueryBytes(String userId, String pwd, String interfaceId, String serverID, HashMap<String, String> params, String method, List<byte[]> retBytes) throws Exception, IOException {

        if (serverID == null || serverID.isEmpty()) {
            serverID = this.serverID;
        }

        String url = basicUrl;
        url = url.replace("ip", this.serverIp);
        url = url.replace("port", this.serverPort);
        url = url.replace("serverId", serverID);
        StringBuilder newUrl = new StringBuilder(url);
        newUrl.append("method=" + method);
        newUrl.append("&language=" + language);
        newUrl.append("&clientversion=" + clientVersion);
        newUrl.append("&userId=" + userId);
        newUrl.append("&interfaceid=" + interfaceId);
        if (params == null) {
            throw new Exception("error,params is null");
        } else {
            Iterator var12 = params.keySet().iterator();

            String key;
            while (var12.hasNext()) {
                key = (String) var12.next();
                if (key != null && !key.trim().equalsIgnoreCase("")) {
                    newUrl.append("&" + key.trim()).append("=" + ((String) params.get(key)).trim());
                }
            }

            key = String.valueOf(System.currentTimeMillis());
            String nonce = UUID.randomUUID().toString();
            newUrl.append("&timestamp=").append(key);
            newUrl.append("&nonce=").append(nonce);
            HashMap<String, String> signParam = new HashMap();
            signParam.putAll(params);
            signParam.put("serviceNodeId", serverID);
            signParam.put("method", method);
            signParam.put("language", language);
            signParam.put("clientversion", clientVersion);
            signParam.put("userId", userId);
            signParam.put("interfaceid", interfaceId);
            signParam.put("timestamp", key);
            signParam.put("nonce", nonce);
            signParam.put("pwd", pwd);
            String sign = CommHelper.getSign(signParam);
            if (sign.equals("")) {
                throw new Exception("generate sign error");
            } else {
                newUrl.append("&sign=").append(sign);
                CloseableHttpClient httpClient = HttpClients.createDefault();
                HttpGet httpGet = new HttpGet(newUrl.toString());
                CloseableHttpResponse response = null;

                byte retCode;
                try {
                    RequestConfig requestConfig = RequestConfig.custom().setConnectTimeout(this.connTimeOut).setSocketTimeout(this.readTimeOut).build();
                    httpGet.setConfig(requestConfig);
                    response = httpClient.execute(httpGet);
                    HttpEntity entity = response.getEntity();
                    int stateCode = response.getStatusLine().getStatusCode();
                    if (stateCode != 200) {
                        throw new Exception(response.getStatusLine().getReasonPhrase());
                    }

                    byte[] buf = EntityUtils.toByteArray(entity);
                    retBytes.add(buf);
                    retCode = 0;
                } catch (IOException var29) {
                    throw var29;
                } finally {
                    try {
                        if (response != null) {
                            response.close();
                        }

                        if (httpClient != null) {
                            httpClient.close();
                        }
                    } catch (Exception var28) {
                        var28.printStackTrace();
                    }

                }

                return retCode;
            }
        }
    }

    private boolean readClientConfig(String path) throws Exception {
        ConfigHelper.initProperties(path);
        String value = ConfigHelper.getProperty("music_server");
        if (value != null && value.length() > 3) {
            this.serverIp = value.trim();
            value = ConfigHelper.getProperty("music_port");
            if (value != null && !value.equalsIgnoreCase("")) {
                this.serverPort = value.trim();
            } else {
                this.serverPort = "80";
            }

            value = ConfigHelper.getProperty("music_connTimeout");
            int ivalue;
            if (value != null && !value.equalsIgnoreCase("")) {
                try {
                    ivalue = Integer.parseInt(value.trim());
                    if (ivalue > 0 && ivalue < 2147483647) {
                        this.connTimeOut = ivalue * 1000;
                    }
                } catch (Exception var5) {
                    var5.printStackTrace();
                }
            }

            value = ConfigHelper.getProperty("music_readTimeout");
            if (value != null && !value.equalsIgnoreCase("")) {
                try {
                    ivalue = Integer.parseInt(value.trim());
                    if (ivalue > 0 && ivalue < 2147483647) {
                        this.readTimeOut = ivalue * 1000;
                    }
                } catch (Exception var4) {
                    var4.printStackTrace();
                }
            }

            value = ConfigHelper.getProperty("music_ServiceId");
            if (value != null && !value.equalsIgnoreCase("")) {
                this.serverID = value.trim();
            }

            return true;
        } else {
            throw new Exception("Error:can't find music_server value in client.config");
        }
    }
}
